- Main Page
- Related Pages
- Modules
- Data Structures
- Files
- Examples

Modules | Functions
Smart Object Functions
Evas

Functions dealing with Evas smart objects (instances). More...

## Modules
| Clipped Smart Object
| Clipped smart object is a base to construct other smart objects based on the concept of having an internal clipper that is applied to all children objects.
| Box Smart Object
| A box is a convenience smart object that packs children inside it in sequence, using a layouting function specified by the user.
| Table Smart Object.
| Convenience smart object that packs children using a tabular layout using children size hints to define their size and alignment inside their cell space.
| Grid Smart Object.
| Convenience smart object that packs children under a regular grid layout, using their virtual grid location and size to determine children's positions inside the grid object's area.

## Functions
void | evas_smart_legacy_type_register (const char *type, const Eo_Class *klass)
| Registers an object type and its associated class. More...
#define | evas_canvas_smart_objects_calculate() EVAS_CANVAS_ID(EVAS_CANVAS_SUB_ID_SMART_OBJECTS_CALCULATE)
#define | evas_canvas_smart_objects_calculate_count_get(ret) EVAS_CANVAS_ID(EVAS_CANVAS_SUB_ID_SMART_OBJECTS_CALCULATE_COUNT_GET), EO_TYPECHECK(int *, ret)
const Eo_Class * | evas_object_smart_class_get (void)
#define | EVAS_OBJ_SMART_CLASS evas_object_smart_class_get()
#define | EVAS_OBJ_SMART_ID(sub_id) (EVAS_OBJ_SMART_BASE_ID + sub_id)
#define | evas_obj_smart_data_set(data) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_DATA_SET), EO_TYPECHECK(void *, data)
#define | evas_obj_smart_smart_get(smart) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_SMART_GET), EO_TYPECHECK(Evas_Smart **, smart)
#define | evas_obj_smart_member_add(obj) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MEMBER_ADD), EO_TYPECHECK(Evas_Object *, obj)
#define | evas_obj_smart_member_del(obj) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MEMBER_DEL), EO_TYPECHECK(Evas_Object *, obj)
#define | evas_obj_smart_members_get(list) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MEMBERS_GET), EO_TYPECHECK(Eina_List **, list)
#define | evas_obj_smart_iterator_new(it) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_ITERATOR_NEW), EO_TYPECHECK(Eina_Iterator **, it)
#define | evas_obj_smart_callback_priority_add(event, priority, func, data) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_PRIORITY_ADD), EO_TYPECHECK(const char *, event), EO_TYPECHECK(Evas_Callback_Priority, priority), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, data)
#define | evas_obj_smart_callback_del(event, func, ret_data) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_DEL), EO_TYPECHECK(const char *, event), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(void **, ret_data)
#define | evas_obj_smart_callback_del_full(event, func, data, ret_data) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_DEL_FULL), EO_TYPECHECK(const char *, event), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, data), EO_TYPECHECK(void **, ret_data)
#define | evas_obj_smart_callback_call(event, event_info) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_CALL), EO_TYPECHECK(const char *, event), EO_TYPECHECK(void *, event_info)
#define | evas_obj_smart_callbacks_descriptions_set(descriptions, result) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACKS_DESCRIPTIONS_SET), EO_TYPECHECK(const Evas_Smart_Cb_Description *, descriptions), EO_TYPECHECK(Eina_Bool *, result)
#define | evas_obj_smart_callbacks_descriptions_get(class_descriptions, class_count, instance_descriptions, instance_count) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACKS_DESCRIPTIONS_GET), EO_TYPECHECK(const Evas_Smart_Cb_Description ***, class_descriptions), EO_TYPECHECK(unsigned int *, class_count), EO_TYPECHECK(const Evas_Smart_Cb_Description ***, instance_descriptions), EO_TYPECHECK(unsigned int *, instance_count)
#define | evas_obj_smart_callback_description_find(name, class_description, instance_description) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_DESCRIPTION_FIND), EO_TYPECHECK(const char *, name), EO_TYPECHECK(const Evas_Smart_Cb_Description **, class_description), EO_TYPECHECK(const Evas_Smart_Cb_Description **, instance_description)
#define | evas_obj_smart_need_recalculate_set(value) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_NEED_RECALCULATE_SET), EO_TYPECHECK(Eina_Bool, value)
#define | evas_obj_smart_need_recalculate_get(need_recalculate) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_NEED_RECALCULATE_GET), EO_TYPECHECK(Eina_Bool *, need_recalculate)
#define | evas_obj_smart_calculate() EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALCULATE)
#define | evas_obj_smart_changed() EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CHANGED)
#define | evas_obj_smart_add() EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_ADD)
#define | evas_obj_smart_del() EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_DEL)
#define | evas_obj_smart_resize(w, h) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_RESIZE), EO_TYPECHECK(Evas_Coord, w), EO_TYPECHECK(Evas_Coord, h)
#define | evas_obj_smart_move(x, y) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MOVE), EO_TYPECHECK(Evas_Coord, x), EO_TYPECHECK(Evas_Coord, y)
#define | evas_obj_smart_show() EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_SHOW)
#define | evas_obj_smart_hide() EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_HIDE)
#define | evas_obj_smart_color_set(r, g, b, a) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_COLOR_SET), EO_TYPECHECK(int, r), EO_TYPECHECK(int, g), EO_TYPECHECK(int, b), EO_TYPECHECK(int, a)
#define | evas_obj_smart_clip_set(clip) EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CLIP_SET), EO_TYPECHECK(Evas_Object *, clip)
#define | evas_obj_smart_clip_unset() EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CLIP_UNSET)
enum | { EVAS_OBJ_SMART_SUB_ID_DATA_SET, EVAS_OBJ_SMART_SUB_ID_SMART_GET, EVAS_OBJ_SMART_SUB_ID_MEMBER_ADD, EVAS_OBJ_SMART_SUB_ID_MEMBER_DEL, EVAS_OBJ_SMART_SUB_ID_MEMBERS_GET, EVAS_OBJ_SMART_SUB_ID_ITERATOR_NEW, EVAS_OBJ_SMART_SUB_ID_CALLBACKS_DESCRIPTIONS_SET, EVAS_OBJ_SMART_SUB_ID_CALLBACKS_DESCRIPTIONS_GET, EVAS_OBJ_SMART_SUB_ID_CALLBACK_DESCRIPTION_FIND, EVAS_OBJ_SMART_SUB_ID_NEED_RECALCULATE_SET, EVAS_OBJ_SMART_SUB_ID_NEED_RECALCULATE_GET, EVAS_OBJ_SMART_SUB_ID_CALCULATE, EVAS_OBJ_SMART_SUB_ID_CHANGED, EVAS_OBJ_SMART_SUB_ID_ATTACH, EVAS_OBJ_SMART_SUB_ID_ADD, EVAS_OBJ_SMART_SUB_ID_DEL, EVAS_OBJ_SMART_SUB_ID_RESIZE, EVAS_OBJ_SMART_SUB_ID_MOVE, EVAS_OBJ_SMART_SUB_ID_SHOW, EVAS_OBJ_SMART_SUB_ID_HIDE, EVAS_OBJ_SMART_SUB_ID_COLOR_SET, EVAS_OBJ_SMART_SUB_ID_CLIP_SET, EVAS_OBJ_SMART_SUB_ID_CLIP_UNSET, EVAS_OBJ_SMART_SUB_ID_LAST }
Eo_Op | EVAS_OBJ_SMART_BASE_ID
#define | evas_obj_smart_parent_get(smart_parent) EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_PARENT_GET), EO_TYPECHECK(Evas_Object **, smart_parent)
#define | evas_obj_smart_data_get(data) EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_DATA_GET), EO_TYPECHECK(void **, data)
#define | evas_obj_smart_type_check(type, type_check) EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_TYPE_CHECK), EO_TYPECHECK(const char *, type), EO_TYPECHECK(Eina_Bool *, type_check)
#define | evas_obj_smart_type_check_ptr(type, type_check) EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_TYPE_CHECK_PTR), EO_TYPECHECK(const char *, type), EO_TYPECHECK(Eina_Bool *, type_check)
#define | evas_obj_smart_move_children_relative(dx, dy) EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_MOVE_CHILDREN_RELATIVE), EO_TYPECHECK(Evas_Coord, dx), EO_TYPECHECK(Evas_Coord, dy)
Evas_Object * | evas_object_smart_add (Evas *e, Evas_Smart *s)
| Instantiates a new smart object described by `s`. More...
void | evas_object_smart_member_add (Evas_Object *obj, Evas_Object *smart_obj)
| Set an Evas object as a member of a given smart object. More...
void | evas_object_smart_member_del (Evas_Object *obj)
| Removes a member object from a given smart object. More...
Evas_Object * | evas_object_smart_parent_get (const Evas_Object *obj)
| Gets the parent smart object of a given Evas object, if it has one. More...
Eina_Bool | evas_object_smart_type_check (const Evas_Object *obj, const char *type)
| Checks whether a given smart object or any of its smart object parents is of a given smart class. More...
Eina_Bool | evas_object_smart_type_check_ptr (const Evas_Object *obj, const char *type)
| Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison. More...
Evas_Smart * | evas_object_smart_smart_get (const Evas_Object *obj)
| Get the Evas_Smart from which `obj` smart object was created. More...
void * | evas_object_smart_data_get (const Evas_Object *obj)
| Retrieve user data stored on a given smart object. More...
void | evas_object_smart_data_set (Evas_Object *obj, void *data)
| Store a pointer to user data for a given smart object. More...
void | evas_object_smart_callback_add (Evas_Object *obj, const char *event, Evas_Smart_Cb func, const void *data)
| Add (register) a callback function to the smart event specified by `event` on the smart object `obj`. More...
void | evas_object_smart_callback_priority_add (Evas_Object *obj, const char *event, Evas_Callback_Priority priority, Evas_Smart_Cb func, const void *data)
| Add (register) a callback function to the smart event specified by `event` on the smart object `obj`. More...
void * | evas_object_smart_callback_del (Evas_Object *obj, const char *event, Evas_Smart_Cb func)
| Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`. More...
void * | evas_object_smart_callback_del_full (Evas_Object *obj, const char *event, Evas_Smart_Cb func, const void *data)
| Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`. More...
void | evas_object_smart_callback_call (Evas_Object *obj, const char *event, void *event_info)
| Call a given smart callback on the smart object `obj`. More...
Eina_Bool | evas_object_smart_callbacks_descriptions_set (Evas_Object *obj, const Evas_Smart_Cb_Description *descriptions)
| Set an smart object instance's smart callbacks descriptions. More...
void | evas_object_smart_callbacks_descriptions_get (const Evas_Object *obj, const Evas_Smart_Cb_Description ***class_descriptions, unsigned int *class_count, const Evas_Smart_Cb_Description ***instance_descriptions, unsigned int *instance_count)
| Retrieve an smart object's know smart callback descriptions (both instance and class ones). More...
void | evas_object_smart_changed (Evas_Object *obj)
| Mark smart object as changed, dirty. More...
void | evas_object_smart_need_recalculate_set (Evas_Object *obj, Eina_Bool value)
| Set or unset the flag signalling that a given smart object needs to get recalculated. More...
Eina_Bool | evas_object_smart_need_recalculate_get (const Evas_Object *obj)
| Get the value of the flag signalling that a given smart object needs to get recalculated. More...
void | evas_object_smart_calculate (Evas_Object *obj)
| Call the calculate() smart function immediately on a given smart object. More...
void | evas_smart_objects_calculate (Evas *e)
| Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas. More...
int | evas_smart_objects_calculate_count_get (const Evas *e)
| This gets the internal counter that counts the number of smart calculations. More...
Eina_List * | evas_object_smart_members_get (const Evas_Object *obj)
| Retrieves the list of the member objects of a given Evas smart object. More...
Eina_Iterator * | evas_object_smart_iterator_new (const Evas_Object *obj)
| Retrieves an iterator of the member objects of a given Evas smart object. More...
void | evas_object_smart_callback_description_find (const Evas_Object *obj, const char *name, const Evas_Smart_Cb_Description **class_description, const Evas_Smart_Cb_Description **instance_description)
| Find callback description for callback called name. More...
const void * | evas_object_smart_interface_get (const Evas_Object *obj, const char *name)
| Retrieve an Evas smart object's interface, by name string pointer. More...
void * | evas_object_smart_interface_data_get (const Evas_Object *obj, const Evas_Smart_Interface *iface)
| Retrieve an Evas smart object interface's private data. More...
void | evas_object_smart_move_children_relative (Evas_Object *obj, Evas_Coord dx, Evas_Coord dy)
| Moves all children objects of a given smart object relative to a given offset. More...

## Detailed Description

Functions dealing with Evas smart objects (instances).

Smart objects are groupings of primitive Evas objects that behave as a cohesive group. For instance, a file manager icon may be a smart object composed of an image object, a text label and two rectangles that appear behind the image and text when the icon is selected. As a smart object, the normal Evas object API could be used on the icon object.

Besides that, generally smart objects implement a specific API, so that users interact with its own custom features. The API takes form of explicit exported functions one may call and smart callbacks.

# Smart events and callbacks

Smart objects can elect events (smart events, from now on) occurring inside of them to be reported back to their users via callback functions (smart callbacks). This way, you can extend Evas' own object events. They are defined by an event string, which identifies them uniquely. There's also a function prototype definition for the callback functions: Evas_Smart_Cb.

When defining an Evas_Smart_Class, smart object implementors are strongly encouraged to properly set the Evas_Smart_Class::callbacks callbacks description array, so that the users of the smart object can have introspection on its events API at run time.

See some examples of this group of functions.

See Also
  Smart Functions for class definitions.

## Macro Definition Documentation

#define evas_canvas_smart_objects_calculate | ( |  | ) | EVAS_CANVAS_ID(EVAS_CANVAS_SUB_ID_SMART_OBJECTS_CALCULATE)

Since
  1.8

Call user-provided calculate() smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas.

See Also
  evas_smart_objects_calculate

Referenced by evas_smart_objects_calculate().

#define evas_obj_smart_parent_get | ( |  | smart_parent | ) | EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_PARENT_GET), EO_TYPECHECK(Evas_Object **, smart_parent)

Since
  1.8

Gets the parent smart object of a given Evas object, if it has one.

Parameters

  [out] | smart_parent | out

See Also
  evas_object_smart_parent_get

Referenced by evas_object_smart_parent_get().

#define evas_canvas_smart_objects_calculate_count_get | ( |  | ret | ) | EVAS_CANVAS_ID(EVAS_CANVAS_SUB_ID_SMART_OBJECTS_CALCULATE_COUNT_GET), EO_TYPECHECK(int *, ret)

Since
  1.8

This gets the internal counter that counts the number of smart calculations

Parameters

  [out] | ret |

See Also
  evas_smart_objects_calculate_count_get

Referenced by evas_smart_objects_calculate_count_get().

#define evas_obj_smart_data_set | ( |  | data | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_DATA_SET), EO_TYPECHECK(void *, data)

Since
  1.8

Store a pointer to user data for a given smart object.

Parameters

  [in] | data | in

See Also
  evas_object_smart_data_set

Referenced by evas_object_smart_data_set().

#define evas_obj_smart_smart_get | ( |  | smart | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_SMART_GET), EO_TYPECHECK(Evas_Smart **, smart)

Since
  1.8

Get the Evas_Smart from which smart object was created.

Parameters

  [out] | smart | out

See Also
  evas_object_smart_smart_get

Referenced by evas_object_smart_smart_get().

#define evas_obj_smart_member_add | ( |  | obj | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MEMBER_ADD), EO_TYPECHECK(Evas_Object *, obj)

Since
  1.8

Set an Evas object as a member of a given smart object.

Parameters

  [in] | obj | in

See Also
  evas_object_smart_member_add

Referenced by evas_object_smart_member_add().

#define evas_obj_smart_member_del | ( |  | obj | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MEMBER_DEL), EO_TYPECHECK(Evas_Object *, obj)

Since
  1.8

Removes a member object from a given smart object.

Parameters

  [in] | obj | in

See Also
  evas_object_smart_member_del

Referenced by evas_object_smart_member_del().

#define evas_obj_smart_members_get | ( |  | list | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MEMBERS_GET), EO_TYPECHECK(Eina_List **, list)

Since
  1.8

Retrieves the list of the member objects of a given Evas smart object

Parameters

  [out] | list | out

See Also
  evas_object_smart_members_get
  evas_object_smart_iterator_new

Referenced by evas_object_smart_members_get().

#define evas_obj_smart_iterator_new | ( |  | it | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_ITERATOR_NEW), EO_TYPECHECK(Eina_Iterator **, it)

Since
  1.8

Retrieves an iterator of the member objects of a given Evas smart object

Parameters

  [out] | it | out

See Also
  evas_object_smart_iterator_new
  evas_object_smart_members_get

Referenced by evas_object_smart_iterator_new().

#define evas_obj_smart_callback_priority_add | ( |  | event,
|  |  | priority,
|  |  | func,
|  |  | data
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_PRIORITY_ADD), EO_TYPECHECK(const char *, event), EO_TYPECHECK(Evas_Callback_Priority, priority), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, data)

Since
  1.8

Add (register) a callback function to the smart event specified by `event` on the smart object. Except for the priority field, it's exactly the same as evas_object_smart_callback_add

Parameters

  [in] | event | in
  [in] | priority | in
  [in] | func | in
  [in] | data | in

See Also
  evas_object_smart_callback_priority_add

#define evas_obj_smart_callback_del | ( |  | event,
|  |  | func,
|  |  | ret_data
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_DEL), EO_TYPECHECK(const char *, event), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(void **, ret_data)

Since
  1.8

Delete (unregister) a callback function from the smart event specified by `event` on the smart object.

Parameters

  [in] | event | in
  [in] | func | in
  [out] | ret_data | out

See Also
  evas_object_smart_callback_del

#define evas_obj_smart_callback_del_full | ( |  | event,
|  |  | func,
|  |  | data,
|  |  | ret_data
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_DEL_FULL), EO_TYPECHECK(const char *, event), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, data), EO_TYPECHECK(void **, ret_data)

Since
  1.8

Delete (unregister) a callback function from the smart event specified by `event` on the smart object.

Parameters

  [in] | event | in
  [in] | func | in
  [in] | data | in
  [out] | ret_data | out

See Also
  evas_object_smart_callback_del_full

#define evas_obj_smart_callback_call | ( |  | event,
|  |  | event_info
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_CALL), EO_TYPECHECK(const char *, event), EO_TYPECHECK(void *, event_info)

Since
  1.8

Call a given smart callback on the smart object.

Parameters

  [in] | event |
  [in] | event_info |

See Also
  evas_object_smart_callback_call

#define evas_obj_smart_callbacks_descriptions_set | ( |  | descriptions,
|  |  | result
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACKS_DESCRIPTIONS_SET), EO_TYPECHECK(const Evas_Smart_Cb_Description *, descriptions), EO_TYPECHECK(Eina_Bool *, result)

Since
  1.8

Set an smart object instance's smart callbacks descriptions.

Parameters

  [in] | descriptions | in
  [out] | result | out

See Also
  evas_object_smart_callbacks_descriptions_set

Referenced by evas_object_smart_callbacks_descriptions_set().

#define evas_obj_smart_callbacks_descriptions_get | ( |  | class_descriptions,
|  |  | class_count,
|  |  | instance_descriptions,
|  |  | instance_count
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACKS_DESCRIPTIONS_GET), EO_TYPECHECK(const Evas_Smart_Cb_Description ***, class_descriptions), EO_TYPECHECK(unsigned int *, class_count), EO_TYPECHECK(const Evas_Smart_Cb_Description ***, instance_descriptions), EO_TYPECHECK(unsigned int *, instance_count)

Since
  1.8

Retrieve an smart object's know smart callback descriptions (both instance and class ones).

Parameters

  [out] | class_descriptions | out
  [out] | class_count | out
  [out] | instance_descriptions | out
  [out] | instance_count | out

See Also
  evas_object_smart_callbacks_descriptions_get

Referenced by evas_object_smart_callbacks_descriptions_get().

#define evas_obj_smart_callback_description_find | ( |  | name,
|  |  | class_description,
|  |  | instance_description
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALLBACK_DESCRIPTION_FIND), EO_TYPECHECK(const char *, name), EO_TYPECHECK(const Evas_Smart_Cb_Description **, class_description), EO_TYPECHECK(const Evas_Smart_Cb_Description **, instance_description)

Since
  1.8

Find callback description for callback called name.

Parameters

  [in] | name | in
  [out] | class_description | out
  [out] | instance_description | out

See Also
  evas_object_smart_callback_description_find

Referenced by evas_object_smart_callback_description_find().

#define evas_obj_smart_need_recalculate_set | ( |  | value | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_NEED_RECALCULATE_SET), EO_TYPECHECK(Eina_Bool, value)

Since
  1.8

Set or unset the flag signalling that a given smart object needs to get recalculated.

Parameters

  [in] | value | in

See Also
  evas_object_smart_need_recalculate_set

Referenced by evas_object_smart_need_recalculate_set().

#define evas_obj_smart_need_recalculate_get | ( |  | need_recalculate | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_NEED_RECALCULATE_GET), EO_TYPECHECK(Eina_Bool *, need_recalculate)

Since
  1.8

Get the value of the flag signalling that a given smart object needs to get recalculated.

Parameters

  [out] | need_recalculate | out

See Also
  evas_object_smart_need_recalculate_get

Referenced by evas_object_smart_need_recalculate_get().

#define evas_obj_smart_calculate | ( |  | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CALCULATE)

Since
  1.8

Call the calculate() smart function immediately on a given smart object.

See Also
  evas_object_smart_calculate

Referenced by evas_object_smart_calculate().

#define evas_obj_smart_changed | ( |  | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CHANGED)

Since
  1.8

Mark smart object as changed, dirty.

See Also
  evas_object_smart_changed

Referenced by evas_object_smart_changed().

#define evas_obj_smart_add | ( |  | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_ADD)

Since
  1.8

Instantiates a new smart object described by s.

See Also
  evas_object_smart_add

#define evas_obj_smart_del | ( |  | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_DEL)

Since
  1.8

Deletes a smart object.

#define evas_obj_smart_resize | ( |  | w,
|  |  | h
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_RESIZE), EO_TYPECHECK(Evas_Coord, w), EO_TYPECHECK(Evas_Coord, h)

Since
  1.8

No description supplied by the EAPI.

Parameters

  [in] | w |
  [in] | h |

#define evas_obj_smart_move | ( |  | x,
|  |  | y
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_MOVE), EO_TYPECHECK(Evas_Coord, x), EO_TYPECHECK(Evas_Coord, y)

Since
  1.8

No description supplied by the EAPI.

Parameters

  [in] | x |
  [in] | y |

#define evas_obj_smart_show | ( |  | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_SHOW)

Since
  1.8

No description supplied by the EAPI.

#define evas_obj_smart_hide | ( |  | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_HIDE)

Since
  1.8

No description supplied by the EAPI.

#define evas_obj_smart_color_set | ( |  | r,
|  |  | g,
|  |  | b,
|  |  | a
| ) |  | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_COLOR_SET), EO_TYPECHECK(int, r), EO_TYPECHECK(int, g), EO_TYPECHECK(int, b), EO_TYPECHECK(int, a)

Since
  1.8

No description supplied by the EAPI.

Parameters

  [in] | r |
  [in] | g |
  [in] | b |
  [in] | a |

See Also
  evas_object_smart_color_set

#define evas_obj_smart_clip_set | ( |  | clip | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CLIP_SET), EO_TYPECHECK(Evas_Object *, clip)

Since
  1.8

No description supplied by the EAPI.

Parameters

  [in] | clip |

#define evas_obj_smart_clip_unset | ( |  | ) | EVAS_OBJ_SMART_ID(EVAS_OBJ_SMART_SUB_ID_CLIP_UNSET)

Since
  1.8

No description supplied by the EAPI.

#define evas_obj_smart_data_get | ( |  | data | ) | EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_DATA_GET), EO_TYPECHECK(void **, data)

Since
  1.8

Retrieve user data stored on a given smart object.

Parameters

  [out] | data | out

See Also
  evas_object_smart_data_get

Referenced by evas_object_smart_data_get().

#define evas_obj_smart_type_check | ( |  | type,
|  |  | type_check
| ) |  | EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_TYPE_CHECK), EO_TYPECHECK(const char *, type), EO_TYPECHECK(Eina_Bool *, type_check)

Since
  1.8

Checks whether a given smart object or any of its smart object parents is of a given smart class.

Parameters

  [in] | type | in
  [out] | type_check | out

See Also
  evas_object_smart_type_check

Referenced by evas_object_smart_type_check().

#define evas_obj_smart_type_check_ptr | ( |  | type,
|  |  | type_check
| ) |  | EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_TYPE_CHECK_PTR), EO_TYPECHECK(const char *, type), EO_TYPECHECK(Eina_Bool *, type_check)

Since
  1.8

Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison.

Parameters

  [in] | type | in
  [out] | type_check | out

See Also
  evas_object_smart_type_check_ptr

Referenced by evas_object_smart_type_check_ptr().

#define evas_obj_smart_move_children_relative | ( |  | dx,
|  |  | dy
| ) |  | EVAS_OBJ_ID(EVAS_OBJ_SUB_ID_SMART_MOVE_CHILDREN_RELATIVE), EO_TYPECHECK(Evas_Coord, dx), EO_TYPECHECK(Evas_Coord, dy)

Since
  1.8

Moves all children objects of a given smart object relative to a given offset.

Parameters

  [in] | dx | in
  [in] | dy | in

See Also
  evas_object_smart_move_children_relative

Referenced by evas_object_smart_move_children_relative().

## Function Documentation

void evas_smart_legacy_type_register | ( | const char * | type,
|  | const Eo_Class * | klass
| ) |  |

Registers an object type and its associated class.

LEGACY MECHANISM SUPPORT.

This function is invoked in the class constructor of smart classes. It will add the type and the class into a hash table that will then be used to check the type of an object. This function has been implemented to support legacy mechanism that checks objects types by name. USE IT ONLY FOR LEGACY SUPPORT. Otherwise, it is HIGHLY recommended to use eo_isa.

Parameters

  type | The type (name string) to add.
  klass | The class to associate to the type.

See Also
  eo_isa

References eina_hash_set().

Evas_Object* evas_object_smart_add | ( | Evas * | e,
|  | Evas_Smart * | s
| ) |  |

Instantiates a new smart object described by `s`.

Parameters

  e | the canvas on which to add the object
  s | the Evas_Smart describing the smart object

Returns
  a new Evas_Object handle

This is the function one should use when defining the public function adding an instance of the new smart object to a given canvas. It will take care of setting all of its internals to work as they should, if the user set things properly, as seem on the EVAS_SMART_SUBCLASS_NEW, for example.

Referenced by emotion_object_add().

void evas_object_smart_member_add | ( | Evas_Object * | obj,
|  | Evas_Object * | smart_obj
| ) |  |

Set an Evas object as a member of a given smart object.

Parameters

  obj | The member object
  smart_obj | The smart object

Members will automatically be stacked and layered together with the smart object. The various stacking functions will operate on members relative to the other members instead of the entire canvas, since they now live on an exclusive layer (see evas_object_stack_above(), for more details).

Any `smart_obj` object's specific implementation of the `member_add()` smart function will take place too, naturally.

See Also
  evas_object_smart_member_del()
  evas_object_smart_members_get()

References evas_obj_smart_member_add.

void evas_object_smart_member_del | ( | Evas_Object * | obj | ) |

Removes a member object from a given smart object.

Parameters

  obj | the member object

This removes a member object from a smart object, if it was added to any. The object will still be on the canvas, but no longer associated with whichever smart object it was associated with.

See Also
  evas_object_smart_member_add() for more details
  evas_object_smart_members_get()

References evas_obj_smart_member_del.

Evas_Object* evas_object_smart_parent_get | ( | const Evas_Object * | obj | ) |

Gets the parent smart object of a given Evas object, if it has one.

Parameters

  obj | the Evas object you want to get the parent smart object from

Returns
  Returns the parent smart object of obj or `NULL`, if obj is not a smart member of any

References evas_obj_smart_parent_get.

Eina_Bool evas_object_smart_type_check | ( | const Evas_Object * | obj,
|  | const char * | type
| ) |  |

Checks whether a given smart object or any of its smart object parents is of a given smart class.

Parameters

  obj | An Evas smart object to check the type of
  type | The name (type) of the smart class to check for

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

If `obj` is not a smart object, this call will fail immediately.

This function supports Eo and legacy inheritance mechanisms. However, it is recommended to use eo_isa instead if your object is using Eo from top to bottom.

The checks use smart classes names and string comparison. There is a version of this same check using pointer comparison, since a smart class' name is a single string in Evas.

See Also
  evas_object_smart_type_check_ptr()
  eo_isa

References EINA_FALSE, and evas_obj_smart_type_check.

Eina_Bool evas_object_smart_type_check_ptr | ( | const Evas_Object * | obj,
|  | const char * | type
| ) |  |

Checks whether a given smart object or any of its smart object parents is of a given smart class, using pointer comparison.

Parameters

  obj | An Evas smart object to check the type of
  type | The type (name string) to check for. Must be the name

Returns
  `EINA_TRUE`, if obj or any of its parents is of type type, `EINA_FALSE` otherwise

See Also
  evas_object_smart_type_check() for more details
  eo_isa

References EINA_FALSE, and evas_obj_smart_type_check_ptr.

Evas_Smart* evas_object_smart_smart_get | ( | const Evas_Object * | obj | ) |

Get the Evas_Smart from which `obj` smart object was created.

Parameters

  obj | a smart object

Returns
  the Evas_Smart handle or `NULL`, on errors

References evas_obj_smart_smart_get.

Referenced by evas_object_smart_interface_data_get(), and evas_object_smart_interface_get().

void* evas_object_smart_data_get | ( | const Evas_Object * | obj | ) |

Retrieve user data stored on a given smart object.

Parameters

  obj | The smart object's handle

Returns
  A pointer to data stored using evas_object_smart_data_set(), or `NULL`, if none has been set.

See Also
  evas_object_smart_data_set()

References evas_obj_smart_data_get.

Referenced by emotion_object_image_get().

void evas_object_smart_data_set | ( | Evas_Object * | obj,
|  | void * | data
| ) |  |

Store a pointer to user data for a given smart object.

Parameters

  obj | The smart object's handle
  data | A pointer to user data

This data is stored independently of the one set by evas_object_data_set(), naturally.

See Also
  evas_object_smart_data_get()

References evas_obj_smart_data_set.

void evas_object_smart_callback_add | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Add (register) a callback function to the smart event specified by `event` on the smart object `obj`.

Parameters

  obj | a smart object
  event | the event's name string
  func | the callback function
  data | user data to be passed to the callback function

Smart callbacks look very similar to Evas callbacks, but are implemented as smart object's custom ones.

This function adds a function callback to an smart object when the event named `event` occurs in it. The function is `func`.

In the event of a memory allocation error during addition of the callback to the object, evas_alloc_error() should be used to determine the nature of the error, if any, and the program should sensibly try and recover.

A smart callback function must have the Evas_Smart_Cb prototype definition. The first parameter (`data`) in this definition will have the same value passed to evas_object_smart_callback_add() as the `data` parameter, at runtime. The second parameter `obj` is a handle to the object on which the event occurred. The third parameter, `event_info`, is a pointer to data which is totally dependent on the smart object's implementation and semantic for the given event.

There is an infrastructure for introspection on smart objects' events (see evas_smart_callbacks_descriptions_get()), but no internal smart objects on Evas implement them yet.

See Also
  Smart events and callbacks for more details.
  evas_object_smart_callback_del()

References EVAS_CALLBACK_PRIORITY_DEFAULT, and evas_object_smart_callback_priority_add().

void evas_object_smart_callback_priority_add | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Callback_Priority | priority,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Add (register) a callback function to the smart event specified by `event` on the smart object `obj`.

Except for the priority field, it's exactly the same as evas_object_smart_callback_add

Parameters

  obj | a smart object
  event | the event's name string
  priority | The priority of the callback, lower values called first.
  func | the callback function
  data | user data to be passed to the callback function

See Also
  evas_object_smart_callback_add

Since
  1.1

References eina_hash_add(), eina_hash_find(), eina_inlist_append(), EINA_INLIST_GET, eina_stringshare_add(), and EINA_TRUE.

Referenced by evas_object_smart_callback_add().

void* evas_object_smart_callback_del | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Smart_Cb | func
| ) |  |

Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`.

Parameters

  obj | a smart object
  event | the event's name string
  func | the callback function

Returns
  the data pointer

This function removes the first added smart callback on the object `obj` matching the event name `event` and the registered function pointer `func`. If the removal is successful it will also return the data pointer that was passed to evas_object_smart_callback_add() (that will be the same as the parameter) when the callback(s) was(were) added to the canvas. If not successful `NULL` will be returned.

See Also
  evas_object_smart_callback_add() for more details.

References eina_hash_find(), EINA_INLIST_FOREACH, EINA_INLIST_GET, and eina_inlist_remove().

void* evas_object_smart_callback_del_full | ( | Evas_Object * | obj,
|  | const char * | event,
|  | Evas_Smart_Cb | func,
|  | const void * | data
| ) |  |

Delete (unregister) a callback function from the smart event specified by `event` on the smart object `obj`.

Parameters

  obj | a smart object
  event | the event's name string
  func | the callback function
  data | the data pointer that was passed to the callback

Returns
  the data pointer

This function removes the first added smart callback on the object `obj` matching the event name `event`, the registered function pointer `func` and the callback data pointer `data`. If the removal is successful it will also return the data pointer that was passed to evas_object_smart_callback_add() (that will be the same as the parameter) when the callback(s) was(were) added to the canvas. If not successful `NULL` will be returned. A common use would be to remove an exact match of a callback

See Also
  evas_object_smart_callback_add() for more details.

Since
  1.2

Note
  To delete all smart event callbacks which match `type` and `func`, use evas_object_smart_callback_del().

References eina_hash_find(), EINA_INLIST_FOREACH, EINA_INLIST_GET, and eina_inlist_remove().

void evas_object_smart_callback_call | ( | Evas_Object * | obj,
|  | const char * | event,
|  | void * | event_info
| ) |  |

Call a given smart callback on the smart object `obj`.

Parameters

  obj | the smart object
  event | the event's name string
  event_info | pointer to an event specific struct or information to pass to the callback functions registered on this smart event

This should be called internally, from the smart object's own code, when some specific event has occurred and the implementor wants is to pertain to the object's events API (see Smart events and callbacks). The documentation for the smart object should include a list of possible events and what type of `event_info` to expect for each of them. Also, when defining an Evas_Smart_Class, smart object implementors are strongly encouraged to properly set the Evas_Smart_Class::callbacks callbacks description array, so that the users of the smart object can have introspection on its events API at run time.

References eina_hash_find().

Referenced by emotion_object_last_position_load(), and emotion_object_last_position_save().

Eina_Bool evas_object_smart_callbacks_descriptions_set | ( | Evas_Object * | obj,
|  | const Evas_Smart_Cb_Description * | descriptions
| ) |  |

Set an smart object instance's smart callbacks descriptions.

Parameters

  obj | A smart object
  descriptions | `NULL` terminated array with Evas_Smart_Cb_Description descriptions. Array elements won't be modified at run time, but references to them and their contents will be made, so this array should be kept alive during the whole object's lifetime.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` on failure.

These descriptions are hints to be used by introspection and are not enforced in any way.

It will not be checked if instance callbacks descriptions have the same name as respective possibly registered in the smart object class. Both are kept in different arrays and users of evas_object_smart_callbacks_descriptions_get() should handle this case as they wish.

Note
  Becase `descriptions` must be `NULL` terminated, and because a `NULL` name makes little sense, too, Evas_Smart_Cb_Description::name must not be `NULL`.
  While instance callbacks descriptions are possible, they are not recommended. Use class callbacks descriptions instead as they make you smart object user's life simpler and will use less memory, as descriptions and arrays will be shared among all instances.

References EINA_FALSE, and evas_obj_smart_callbacks_descriptions_set.

void evas_object_smart_callbacks_descriptions_get | ( | const Evas_Object * | obj,
|  | const Evas_Smart_Cb_Description *** | class_descriptions,
|  | unsigned int * | class_count,
|  | const Evas_Smart_Cb_Description *** | instance_descriptions,
|  | unsigned int * | instance_count
| ) |  |

Retrieve an smart object's know smart callback descriptions (both instance and class ones).

Parameters

  obj | The smart object to get callback descriptions from.
  class_descriptions | Where to store class callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned
  class_count | Returns how many class callbacks descriptions are known.
  instance_descriptions | Where to store instance callbacks descriptions array, if any is known. If no descriptions are known, `NULL` is returned.
  instance_count | Returns how many instance callbacks descriptions are known.

This call searches for registered callback descriptions for both instance and class of the given smart object. These arrays will be sorted by Evas_Smart_Cb_Description::name and also `NULL` terminated, so both class_count and instance_count can be ignored, if the caller wishes so. The terminator `NULL` is not counted in these values.

Note
  If just class descriptions are of interest, try evas_smart_callbacks_descriptions_get() instead.
  Use `NULL` pointers on the descriptions/counters you're not interested in: they'll be ignored by the function.

See Also
  evas_smart_callbacks_descriptions_get()

References evas_obj_smart_callbacks_descriptions_get.

void evas_object_smart_changed | ( | Evas_Object * | obj | ) |

Mark smart object as changed, dirty.

Parameters

  obj | The given Evas smart object

This will flag the given object as needing recalculation, forcefully. As an effect, on the next rendering cycle its calculate() (see Evas_Smart_Class) smart function will be called.

See Also
  evas_object_smart_need_recalculate_set().
  evas_object_smart_calculate().

References evas_obj_smart_changed.

void evas_object_smart_need_recalculate_set | ( | Evas_Object * | obj,
|  | Eina_Bool | value
| ) |  |

Set or unset the flag signalling that a given smart object needs to get recalculated.

Parameters

  obj | the smart object
  value | whether one wants to set (`EINA_TRUE`) or to unset (`EINA_FALSE`) the flag.

If this flag is set, then the `calculate()` smart function of `obj` will be called, if one is provided, during rendering phase of Evas (see evas_render()), after which this flag will be automatically unset.

If that smart function is not provided for the given object, this flag will be left unchanged.

Note
  just setting this flag will not make the canvas' whole scene dirty, by itself, and evas_render() will have no effect. To force that, use evas_object_smart_changed(), that will also call this function automatically, with `EINA_TRUE` as parameter.

See Also
  evas_object_smart_need_recalculate_get()
  evas_object_smart_calculate()
  evas_smart_objects_calculate()

References evas_obj_smart_need_recalculate_set.

Eina_Bool evas_object_smart_need_recalculate_get | ( | const Evas_Object * | obj | ) |

Get the value of the flag signalling that a given smart object needs to get recalculated.

Parameters

  obj | the smart object

Returns
  if flag is set or not.

Note
  this flag will be unset during the rendering phase, when the `calculate()` smart function is called, if one is provided. If it's not provided, then the flag will be left unchanged after the rendering phase.

See Also
  evas_object_smart_need_recalculate_set(), for more details

References EINA_FALSE, and evas_obj_smart_need_recalculate_get.

void evas_object_smart_calculate | ( | Evas_Object * | obj | ) |

Call the calculate() smart function immediately on a given smart object.

Parameters

  obj | the smart object's handle

This will force immediate calculations (see Evas_Smart_Class) needed for renderization of this object and, besides, unset the flag on it telling it needs recalculation for the next rendering phase.

See Also
  evas_object_smart_need_recalculate_set()

References evas_obj_smart_calculate.

void evas_smart_objects_calculate | ( | Evas * | e | ) |

Call user-provided `calculate()` smart functions and unset the flag signalling that the object needs to get recalculated to all smart objects in the canvas.

Parameters

  e | The canvas to calculate all smart objects in

See Also
  evas_object_smart_need_recalculate_set()

References evas_canvas_smart_objects_calculate.

int evas_smart_objects_calculate_count_get | ( | const Evas * | e | ) |

This gets the internal counter that counts the number of smart calculations.

Parameters

  e | The canvas to get the calculate counter from

Whenever evas performs smart object calculations on the whole canvas it increments a counter by 1. This is the smart object calculate counter that this function returns the value of. It starts at the value of 0 and will increase (and eventually wrap around to negative values and so on) by 1 every time objects are calculated. You can use this counter to ensure you don't re-do calculations withint the same calculation generation/run if the calculations maybe cause self-feeding effects.

Since
  1.1

References evas_canvas_smart_objects_calculate_count_get.

Eina_List* evas_object_smart_members_get | ( | const Evas_Object * | obj | ) |

Retrieves the list of the member objects of a given Evas smart object.

Parameters

  obj | the smart object to get members from

Returns
  Returns the list of the member objects of `obj`.

The returned list should be freed with `eina_list_free()` when you no longer need it.

Since
  1.7 This function will return `NULL` when a non-smart object is passed.

See Also
  evas_object_smart_member_add()
  evas_object_smart_member_del()
  evas_object_smart_iterator_new()

References evas_obj_smart_members_get.

Eina_Iterator* evas_object_smart_iterator_new | ( | const Evas_Object * | obj | ) |

Retrieves an iterator of the member objects of a given Evas smart object.

Parameters

  obj | the smart object to get members from

Returns
  Returns the iterator of the member objects of `obj`.

Since
  1.8

See Also
  evas_object_smart_member_add()
  evas_object_smart_member_del()
  evas_object_smart_members_get()

References evas_obj_smart_iterator_new.

void evas_object_smart_callback_description_find | ( | const Evas_Object * | obj,
|  | const char * | name,
|  | const Evas_Smart_Cb_Description ** | class_description,
|  | const Evas_Smart_Cb_Description ** | instance_description
| ) |  |

Find callback description for callback called name.

Parameters

  obj | the smart object.
  name | name of desired callback, must not be `NULL`. The search have a special case for name being the same pointer as registered with Evas_Smart_Cb_Description, one can use it to avoid excessive use of strcmp().
  class_description | pointer to return class description or `NULL` if not found. If parameter is `NULL`, no search will be done on class descriptions.
  instance_description | pointer to return instance description or `NULL` if not found. If parameter is `NULL`, no search will be done on instance descriptions.

Returns
  reference to description if found, `NULL` if not found.

References evas_obj_smart_callback_description_find.

const void* evas_object_smart_interface_get | ( | const Evas_Object * | obj,
|  | const char * | name
| ) |  |

Retrieve an Evas smart object's interface, by name string pointer.

Parameters

  obj | An Evas smart object.
  name | Name string of the desired interface, which must be the same pointer used at the interface's declarion, when creating the smart object obj.

Since
  1.7

Returns
  The interface's handle pointer, if found, `NULL` otherwise.

Examples:
  evas-smart-interface.c.

References evas_object_smart_smart_get(), and _Evas_Smart_Interface::name.

void* evas_object_smart_interface_data_get | ( | const Evas_Object * | obj,
|  | const Evas_Smart_Interface * | iface
| ) |  |

Retrieve an Evas smart object interface's private data.

Parameters

  obj | An Evas smart object.
  iface | The given object's interface handle.

Since
  1.7

Returns
  The object interface's private data blob pointer, if found, `NULL` otherwise.

Examples:
  evas-smart-interface.c.

References evas_object_smart_smart_get().

void evas_object_smart_move_children_relative | ( | Evas_Object * | obj,
|  | Evas_Coord | dx,
|  | Evas_Coord | dy
| ) |  |

Moves all children objects of a given smart object relative to a given offset.

Parameters

  obj | the smart object.
  dx | horizontal offset (delta).
  dy | vertical offset (delta).

This will make each of `obj` object's children to move, from where they before, with those delta values (offsets) on both directions.

Note
  This is most useful on custom smart `move()` functions.
  Clipped smart objects already make use of this function on their `move()` smart function definition.

References evas_obj_smart_move_children_relative.